﻿Procedure draw_box_gauge(parent_canvas, icon_image_id, color_background, color_progress_bar,  color_progress_background, color_frame, color_font, units_text$, Array actdata(1), limit_progress_bottom.f = 100000, limit_progress_upper.f = 100000, limit_bottom_color_progress_bar = 0, limit_bottom_color_progress_background = 0, limit_bottom_color_progress_frame = 0,limit_upper_color_progress_bar = 0, limit_upper_color_progress_background = 0, limit_upper_color_progress_frame = 0)
  If StartVectorDrawing(CanvasVectorOutput(parent_canvas))
    AddPathBox(0, 0, GadgetWidth(parent_canvas), GadgetWidth(parent_canvas))
    VectorSourceColor(color_background) 
    FillPath()   
    
    If actdata(0) < limit_progress_bottom And limit_bottom_color_progress_bar <> 0 And limit_progress_bottom <> 100000
      VectorSourceColor(limit_bottom_color_progress_bar)
    ElseIf actdata(0) >= limit_progress_bottom And limit_progress_bottom <> 100000 And actdata(0) <= limit_progress_upper
      VectorSourceColor(color_progress_bar)
    ElseIf actdata(0) > limit_progress_bottom And limit_upper_color_progress_bar <> 0 And limit_progress_upper <> 100000
      VectorSourceColor(limit_upper_color_progress_bar)
    Else 
      VectorSourceColor(color_progress_bar)
    EndIf
    
    AddPathBox(GadgetWidth(parent_canvas)/12 + GadgetWidth(parent_canvas)/160,GadgetWidth(parent_canvas)/10 + GadgetWidth(parent_canvas)/160,  GadgetWidth(parent_canvas) - GadgetWidth(parent_canvas)/6 - GadgetWidth(parent_canvas)/80, GadgetWidth(parent_canvas) - GadgetWidth(parent_canvas)/5 - GadgetWidth(parent_canvas)/160)
    FillPath()
    
    If actdata(0) < limit_progress_bottom And limit_bottom_color_progress_bar <> 0 And limit_progress_bottom <> 100000
      VectorSourceColor(limit_bottom_color_progress_background)
    ElseIf actdata(0) >= limit_progress_bottom And limit_progress_bottom <> 100000 And actdata(0) <= limit_progress_upper
      VectorSourceColor(color_progress_background)
    ElseIf actdata(0) > limit_progress_bottom And limit_upper_color_progress_bar <> 0 And limit_progress_upper <> 100000
      VectorSourceColor(limit_upper_color_progress_background)
    Else 
      VectorSourceColor(color_progress_background)
    EndIf
    
    AddPathBox(GadgetWidth(parent_canvas)/12 + GadgetWidth(parent_canvas)/160,GadgetWidth(parent_canvas)/10  + GadgetWidth(parent_canvas)/160 ,  GadgetWidth(parent_canvas) - GadgetWidth(parent_canvas)/6 - GadgetWidth(parent_canvas)/79, ((GadgetHeight(parent_canvas)/1.7)/100)*(100 - actdata(0)/4))
    FillPath()
    
    icon_size = GadgetWidth(parent_canvas)/2.5
    Color32.q = color_font
    Color32 = Color32 & $FFFFFFFF  
    MovePathCursor(GadgetWidth(parent_canvas)/2 - icon_size/2 , GadgetHeight(parent_canvas) /2 - icon_size/2)
    DrawVectorImage(ImageID(icon_image_id), Alpha(Color32), icon_size, icon_size)
    
    VectorFont(FontID(0), GadgetHeight(parent_canvas)/7)
    VectorSourceColor(RGBA(255, 255, 255, 255))
    text$ = Str(actdata(0)/4) + units_text$
    MovePathCursor(GadgetHeight(parent_canvas)/4 - VectorTextWidth(text$)/2.2, GadgetHeight(parent_canvas)/1.255 - VectorTextHeight(text$)/2)
    AddPathText(text$)
    FillPath()
    
    avg.f = 0
    For i = 0 To ArraySize(actdata())
      avg = avg + actdata(i)
    Next
    avg = avg/ArraySize(actdata())
    
    MovePathCursor(GadgetWidth(parent_canvas)/2, GadgetHeight(parent_canvas)/1.255)
    AddPathLine(GadgetWidth(parent_canvas)/2 + (i * (GadgetWidth(parent_canvas)/2.8)/ArraySize(actdata())), GadgetHeight(parent_canvas)/1.255)
    DotPath(1,2)
    
    For i = ArraySize(actdata()) To 0 Step -1
      AddPathBox((GadgetWidth(parent_canvas)/2 + (i * (GadgetWidth(parent_canvas)/2.8)/ArraySize(actdata()))), GadgetHeight(parent_canvas)/1.255,  (GadgetWidth(parent_canvas)/2)/(ArraySize(actdata())*2), ((avg - actdata(i))/400)*VectorTextHeight(text$)/2)
      FillPath()
    Next
    
    BeginVectorLayer(255)
    If actdata(0) < limit_progress_bottom And limit_bottom_color_progress_bar <> 0 And limit_progress_bottom <> 100000
      VectorSourceColor(limit_bottom_color_progress_frame)
    ElseIf actdata(0) >= limit_progress_bottom And limit_progress_bottom <> 100000 And actdata(0) <= limit_progress_upper
      VectorSourceColor(color_frame)
    ElseIf actdata(0) > limit_progress_bottom And limit_upper_color_progress_bar <> 0 And limit_progress_upper <> 100000
      VectorSourceColor(limit_upper_color_progress_frame)
    Else 
      VectorSourceColor(color_frame)
    EndIf
    AddPathBox(GadgetWidth(parent_canvas)/12,GadgetWidth(parent_canvas)/10,  GadgetWidth(parent_canvas) - GadgetWidth(parent_canvas)/6, (GadgetWidth(parent_canvas) - GadgetWidth(parent_canvas)/5))
    StrokePath(GadgetWidth(parent_canvas)/80, #PB_Path_RoundCorner)
    ClosePath()
    EndVectorLayer()
    
    StopVectorDrawing()
  EndIf
EndProcedure

UsePNGImageDecoder()
position2.i = 0

If OpenWindow(0, 0, 0, 200, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget | #PB_Window_MaximizeGadget)
  LoadImage(0, #PB_Compiler_FilePath  + "/icons/battery.png")
  AddWindowTimer(0, 123,500)
  CanvasGadget(10, 0, 0, 200, 200)
  LoadFont(0, "Tahoma", 16,  #PB_Font_HighQuality)
  Dim batterydata.i(10)
  draw_box_gauge(10,0,RGBA(255,255,255,255) ,RGBA(255, 128, 0,255), RGBA(255, 245, 204,255), RGBA(255, 128, 0,255),RGBA(0 ,150, 0, 255), "%", batterydata(),50,200,RGBA(255,0,0,255), RGBA(255,200,200,255), RGBA(255,0,0,255), RGBA(0,153,0,255), RGBA(179,255,179,255),RGBA(0,153,0,255))     
  Repeat
    If Event = #PB_Event_Timer And EventTimer() = 123 
      For i=0 To ArraySize(batterydata())
        batterydata(i) = Random(400,0)
      Next
      ; green - RGBA(0,153,0,255), RGBA(179,255,179,255),RGBA(0,153,0,255)
      ; yellow - RGBA(255, 128, 0,255), RGBA(255, 245, 204,255), RGBA(255, 128, 0,255)
      ; red - RGBA(255,0,0,255), RGBA(255,200,200,255), RGBA(255,0,0,255)
      ; blue - RGBA(63,90,191, 255) ,RGBA(239,243,250, 255),RGBA(63,90,191, 255)
      draw_box_gauge(10,0,RGBA(255,255,255,255) ,RGBA(255, 128, 0,255), RGBA(255, 245, 204,255), RGBA(255, 128, 0,255),RGBA(0 ,150, 0, 255), "%", batterydata(),50,200,RGBA(255,0,0,255), RGBA(255,200,200,255), RGBA(255,0,0,255), RGBA(0,153,0,255), RGBA(179,255,179,255),RGBA(0,153,0,255))     
    EndIf   
    If event = #PB_Event_SizeWindow
      If WindowWidth(0) < WindowHeight(0)
        CanvasGadget(10, 0, 0, WindowWidth(0), WindowWidth(0))
      Else
        CanvasGadget(10, 0, 0, WindowHeight(0), WindowHeight(0))
      EndIf
      draw_box_gauge(10,0,RGBA(255,255,255,255) ,RGBA(255, 128, 0,255), RGBA(255, 245, 204,255), RGBA(255, 128, 0,255),RGBA(0 ,150, 0, 255), "%", batterydata(),50,200,RGBA(255,0,0,255), RGBA(255,200,200,255), RGBA(255,0,0,255), RGBA(0,153,0,255), RGBA(179,255,179,255),RGBA(0,153,0,255))     
    EndIf
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

; IDE Options = PureBasic 5.71 LTS (Windows - x64)
; CursorPosition = 84
; FirstLine = 68
; Folding = -
; EnableXP